=== debian/changelog ===
libvpl-tools (1.4.0-2) unstable; urgency=medium

  * patches: Fix build with gcc-15. (Closes: #1097288)

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 19 Aug 2025 21:16:46 +0300

libvpl-tools (1.4.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-depends on libvpl-dev.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 12 Aug 2025 09:25:47 +0300
