=== debian/control ===
Source: libvpl-tools
Section: graphics
Priority: optional
Maintainer: Timo Aaltonen <tjaalton@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 pkgconf,
 libdrm-dev,
 libva-dev,
 libvpl-dev (>= 1:2.15.0),
 libx11-dev,
 libx11-xcb-dev,
 libxcb-present-dev,
 libxcb-dri3-dev,
 libwayland-dev,
 wayland-protocols,
Standards-Version: 4.7.0
Homepage: https://github.com/intel/libvpl-tools
Vcs-Browser: https://salsa.debian.org/debian/libvpl-tools
Vcs-Git: https://salsa.debian.org/debian/libvpl-tools.git
Rules-Requires-Root: no

Package: libvpl-tools
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: onevpl-tools
Provides: onevpl-tools
Replaces: onevpl-tools
Description: Intel Video Processing Library -- command line tools
 Intel Video Processing Library (Intel VPL) provides access to hardware
 accelerated video decode, encode, and processing capabilities on Intel
 GPUs to support AI visual inference, media delivery, cloud gaming, and virtual
 desktop infrastructure use cases.
 .
 This package includes the command line tools.
