=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# PGP signature mangle, so foo.tar.gz has foo.tar.gz.sig
#opts="pgpsigurlmangle=s%$%.sig%"

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libvpl-tools-$1.tar.gz%" \
   https://github.com/intel/libvpl-tools/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
