## libvpl-tools 1.5.0

=== debian/changelog ===
libvpl-tools (1.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Timo Aaltonen <tjaalton@debian.org>  Tue, 24 Feb 2026 09:41:19 +0200
